Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 787)
@@ -831,16 +866,16 @@
 	      sensibFlux,q2,zdqdif,zdqsdif,lastcall)
 
-           zdtdif(1:ngridmx,1:nlayermx)=zdhdif(1:ngridmx,1:nlayermx)*zpopsk(1:ngridmx,1:nlayermx) ! for diagnostic only
-	   zdqevap(1:ngridmx,1:nlayermx)=0.
+           zdtdif(1:ngrid,1:nlayermx)=zdhdif(1:ngrid,1:nlayermx)*zpopsk(1:ngrid,1:nlayermx) ! for diagnostic only
+	   zdqevap(1:ngrid,1:nlayermx)=0.
 
          end if !turbdiff
 
-         pdv(1:ngridmx,1:nlayermx)=pdv(1:ngridmx,1:nlayermx)+zdvdif(1:ngridmx,1:nlayermx)
-         pdu(1:ngridmx,1:nlayermx)=pdu(1:ngridmx,1:nlayermx)+zdudif(1:ngridmx,1:nlayermx)
-         pdt(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)+zdtdif(1:ngridmx,1:nlayermx)
-         zdtsurf(1:ngridmx)=zdtsurf(1:ngridmx)+zdtsdif(1:ngridmx)
+         pdv(1:ngrid,1:nlayermx)=pdv(1:ngrid,1:nlayermx)+zdvdif(1:ngrid,1:nlayermx)
+         pdu(1:ngrid,1:nlayermx)=pdu(1:ngrid,1:nlayermx)+zdudif(1:ngrid,1:nlayermx)
+         pdt(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)+zdtdif(1:ngrid,1:nlayermx)
+         zdtsurf(1:ngrid)=zdtsurf(1:ngrid)+zdtsdif(1:ngrid)
          if (tracer) then 
-           pdq(1:ngridmx,1:nlayermx,1:nqmx)=pdq(1:ngridmx,1:nlayermx,1:nqmx)+ zdqdif(1:ngridmx,1:nlayermx,1:nqmx) 
-           dqsurf(1:ngridmx,1:nqmx)=dqsurf(1:ngridmx,1:nqmx) + zdqsdif(1:ngridmx,1:nqmx)
+           pdq(1:ngrid,1:nlayermx,1:nq)=pdq(1:ngrid,1:nlayermx,1:nq)+ zdqdif(1:ngrid,1:nlayermx,1:nq) 
+           dqsurf(1:ngrid,1:nq)=dqsurf(1:ngrid,1:nq) + zdqsdif(1:ngrid,1:nq)
          end if ! of if (tracer)
 
@@ -899,8 +934,9 @@
          if(.not.newtonian)then
 
-            zdtsurf(1:ngridmx) = zdtsurf(1:ngridmx) + (fluxrad(1:ngridmx) + fluxgrd(1:ngridmx))/capcal(1:ngridmx)
-
-         endif
-
+            zdtsurf(1:ngrid) = zdtsurf(1:ngrid) + (fluxrad(1:ngrid) + fluxgrd(1:ngrid))/capcal(1:ngrid)
+
+         endif
+
+      print*,'end TURBULENCE'
       endif ! of if (calldifv)
 
@@ -912,8 +948,8 @@
       if(calladj) then
 
-         zdh(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)/zpopsk(1:ngridmx,1:nlayermx)
-         zduadj(1:ngridmx,1:nlayermx)=0.0
-         zdvadj(1:ngridmx,1:nlayermx)=0.0
-         zdhadj(1:ngridmx,1:nlayermx)=0.0
+         zdh(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)/zpopsk(1:ngrid,1:nlayermx)
+         zduadj(1:ngrid,1:nlayermx)=0.0
+         zdvadj(1:ngrid,1:nlayermx)=0.0
+         zdhadj(1:ngrid,1:nlayermx)=0.0
 
 
@@ -925,11 +961,11 @@
               zdqadj)
 
-         pdu(1:ngridmx,1:nlayermx) = pdu(1:ngridmx,1:nlayermx) + zduadj(1:ngridmx,1:nlayermx)
-         pdv(1:ngridmx,1:nlayermx) = pdv(1:ngridmx,1:nlayermx) + zdvadj(1:ngridmx,1:nlayermx)
-         pdt(1:ngridmx,1:nlayermx)    = pdt(1:ngridmx,1:nlayermx) + zdhadj(1:ngridmx,1:nlayermx)*zpopsk(1:ngridmx,1:nlayermx)
-         zdtadj(1:ngridmx,1:nlayermx) = zdhadj(1:ngridmx,1:nlayermx)*zpopsk(1:ngridmx,1:nlayermx) ! for diagnostic only
+         pdu(1:ngrid,1:nlayermx) = pdu(1:ngrid,1:nlayermx) + zduadj(1:ngrid,1:nlayermx)
+         pdv(1:ngrid,1:nlayermx) = pdv(1:ngrid,1:nlayermx) + zdvadj(1:ngrid,1:nlayermx)
+         pdt(1:ngrid,1:nlayermx)    = pdt(1:ngrid,1:nlayermx) + zdhadj(1:ngrid,1:nlayermx)*zpopsk(1:ngrid,1:nlayermx)
+         zdtadj(1:ngrid,1:nlayermx) = zdhadj(1:ngrid,1:nlayermx)*zpopsk(1:ngrid,1:nlayermx) ! for diagnostic only
  
          if(tracer) then 
-            pdq(1:ngridmx,1:nlayermx,1:nqmx) = pdq(1:ngridmx,1:nlayermx,1:nqmx) + zdqadj(1:ngridmx,1:nlayermx,1:nqmx) 
+            pdq(1:ngrid,1:nlayermx,1:nq) = pdq(1:ngrid,1:nlayermx,1:nq) + zdqadj(1:ngrid,1:nlayermx,1:nq) 
          end if
 
@@ -959,5 +995,6 @@
          endif
          !-------------------------
-               
+         
+      print*,'end CONVADJ'
       endif ! of if(calladj)
 
@@ -980,10 +1017,10 @@
 
 
-         pdt(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)+zdtc(1:ngridmx,1:nlayermx)
-         pdv(1:ngridmx,1:nlayermx)=pdv(1:ngridmx,1:nlayermx)+zdvc(1:ngridmx,1:nlayermx)
-         pdu(1:ngridmx,1:nlayermx)=pdu(1:ngridmx,1:nlayermx)+zduc(1:ngridmx,1:nlayermx)
-         zdtsurf(1:ngridmx) = zdtsurf(1:ngridmx) + zdtsurfc(1:ngridmx)
-
-         pdq(1:ngridmx,1:nlayermx,1:nqmx)=pdq(1:ngridmx,1:nlayermx,1:nqmx)+ zdqc(1:ngridmx,1:nlayermx,1:nqmx) 
+         pdt(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)+zdtc(1:ngrid,1:nlayermx)
+         pdv(1:ngrid,1:nlayermx)=pdv(1:ngrid,1:nlayermx)+zdvc(1:ngrid,1:nlayermx)
+         pdu(1:ngrid,1:nlayermx)=pdu(1:ngrid,1:nlayermx)+zduc(1:ngrid,1:nlayermx)
+         zdtsurf(1:ngrid) = zdtsurf(1:ngrid) + zdtsurfc(1:ngrid)
+
+         pdq(1:ngrid,1:nlayermx,1:nq)=pdq(1:ngrid,1:nlayermx,1:nq)+ zdqc(1:ngrid,1:nlayermx,1:nq) 
          ! Note: we do not add surface co2ice tendency
          ! because qsurf(:,igcm_co2_ice) is updated in condens_co2cloud
@@ -1021,14 +1058,14 @@
 !             ----------------
 
-	       dqmoist(1:ngridmx,1:nlayermx,1:nqmx)=0.
-	       dtmoist(1:ngridmx,1:nlayermx)=0.
-
-               call moistadj(pt,pq,pdq,pplev,pplay,dtmoist,dqmoist,ptimestep,rneb_man)
-
-               pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap)   &
-	                  +dqmoist(1:ngridmx,1:nlayermx,igcm_h2o_vap)
-               pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) =pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice)     &
-                          +dqmoist(1:ngridmx,1:nlayermx,igcm_h2o_ice)
-               pdt(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)+dtmoist(1:ngridmx,1:nlayermx)
+	       dqmoist(1:ngrid,1:nlayermx,1:nq)=0.
+	       dtmoist(1:ngrid,1:nlayermx)=0.
+
+               call moistadj(ngrid,nq,pt,pq,pdq,pplev,pplay,dtmoist,dqmoist,ptimestep,rneb_man)
+
+               pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) = pdq(1:ngrid,1:nlayermx,igcm_h2o_vap)   &
+	                  +dqmoist(1:ngrid,1:nlayermx,igcm_h2o_vap)
+               pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) =pdq(1:ngrid,1:nlayermx,igcm_h2o_ice)     &
+                          +dqmoist(1:ngrid,1:nlayermx,igcm_h2o_ice)
+               pdt(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)+dtmoist(1:ngrid,1:nlayermx)
 
                !-------------------------
@@ -1036,5 +1073,5 @@
                if(enertest)then
                   dEtot=cpp*SUM(massarea(:,:)*dtmoist(:,:))/totarea
-                  do ig = 1, ngrid
+                  do ig=1,ngrid
                      madjdE(ig) = cpp*SUM(mass(:,:)*dtmoist(:,:))
                   enddo
@@ -1055,14 +1092,14 @@
 !        --------------------------------
 
-               call largescale(ptimestep,pplev,pplay,pt,pq,pdt,pdq,dtlscale,dqvaplscale,dqcldlscale,rneb_lsc)
-
-               pdt(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)+dtlscale(1:ngridmx,1:nlayermx)
-               pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap)+dqvaplscale(1:ngridmx,1:nlayermx)
-               pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice)+dqcldlscale(1:ngridmx,1:nlayermx)
+               call largescale(ngrid,nq,ptimestep,pplev,pplay,pt,pq,pdt,pdq,dtlscale,dqvaplscale,dqcldlscale,rneb_lsc)
+
+               pdt(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)+dtlscale(1:ngrid,1:nlayermx)
+               pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) = pdq(1:ngrid,1:nlayermx,igcm_h2o_vap)+dqvaplscale(1:ngrid,1:nlayermx)
+               pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) = pdq(1:ngrid,1:nlayermx,igcm_h2o_ice)+dqcldlscale(1:ngrid,1:nlayermx)
 
                !-------------------------
                ! test energy conservation
                if(enertest)then
-                  do ig = 1, ngrid
+                  do ig=1,ngrid
                      lscaledE(ig) = cpp*SUM(mass(:,:)*dtlscale(:,:))
                   enddo
@@ -1083,5 +1120,5 @@
                ! compute cloud fraction
                do l = 1, nlayer
-                  do ig = 1,ngrid
+                  do ig=1,ngrid
                      cloudfrac(ig,l)=MAX(rneb_lsc(ig,l),rneb_man(ig,l)) 
                   enddo
@@ -1096,19 +1133,19 @@
             if(waterrain)then
 
-               zdqrain(1:ngridmx,1:nlayermx,1:nqmx) = 0.0
-               zdqsrain(1:ngridmx)    = 0.0
-               zdqssnow(1:ngridmx)    = 0.0
-
-               call rain(ptimestep,pplev,pplay,pt,pdt,pq,pdq,            &
+               zdqrain(1:ngrid,1:nlayermx,1:nq) = 0.0
+               zdqsrain(1:ngrid)    = 0.0
+               zdqssnow(1:ngrid)    = 0.0
+
+               call rain(ngrid,nq,ptimestep,pplev,pplay,pt,pdt,pq,pdq,            &
                    zdtrain,zdqrain,zdqsrain,zdqssnow,cloudfrac)
 
-               pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_vap) &
-	             +zdqrain(1:ngridmx,1:nlayermx,igcm_h2o_vap)
-               pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) = pdq(1:ngridmx,1:nlayermx,igcm_h2o_ice) &
-	             +zdqrain(1:ngridmx,1:nlayermx,igcm_h2o_ice)
-               pdt(1:ngridmx,1:nlayermx) = pdt(1:ngridmx,1:nlayermx)+zdtrain(1:ngridmx,1:nlayermx)
-               dqsurf(1:ngridmx,igcm_h2o_vap) = dqsurf(1:ngridmx,igcm_h2o_vap)+zdqsrain(1:ngridmx) ! a bug was here
-               dqsurf(1:ngridmx,igcm_h2o_ice) = dqsurf(1:ngridmx,igcm_h2o_ice)+zdqssnow(1:ngridmx)
-               rainout(1:ngridmx)             = zdqsrain(1:ngridmx)+zdqssnow(1:ngridmx) ! diagnostic   
+               pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) = pdq(1:ngrid,1:nlayermx,igcm_h2o_vap) &
+	             +zdqrain(1:ngrid,1:nlayermx,igcm_h2o_vap)
+               pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) = pdq(1:ngrid,1:nlayermx,igcm_h2o_ice) &
+	             +zdqrain(1:ngrid,1:nlayermx,igcm_h2o_ice)
+               pdt(1:ngrid,1:nlayermx) = pdt(1:ngrid,1:nlayermx)+zdtrain(1:ngrid,1:nlayermx)
+               dqsurf(1:ngrid,igcm_h2o_vap) = dqsurf(1:ngrid,igcm_h2o_vap)+zdqsrain(1:ngrid) ! a bug was here
+               dqsurf(1:ngrid,igcm_h2o_ice) = dqsurf(1:ngrid,igcm_h2o_ice)+zdqssnow(1:ngrid)
+               rainout(1:ngrid)             = zdqsrain(1:ngrid)+zdqssnow(1:ngrid) ! diagnostic   
 
 
@@ -1147,6 +1184,6 @@
 !        ------------- 
         if (sedimentation) then 
-           zdqsed(1:ngridmx,1:nlayermx,1:nqmx) = 0.0
-           zdqssed(1:ngridmx,1:nqmx)  = 0.0
+           zdqsed(1:ngrid,1:nlayermx,1:nq) = 0.0
+           zdqssed(1:ngrid,1:nq)  = 0.0
 
 
@@ -1179,6 +1216,6 @@
               ! and as in rain.F90, whether it falls as rain or snow depends
               ! only on the surface temperature
-           pdq(1:ngridmx,1:nlayermx,1:nqmx) = pdq(1:ngridmx,1:nlayermx,1:nqmx) + zdqsed(1:ngridmx,1:nlayermx,1:nqmx)
-           dqsurf(1:ngridmx,1:nqmx) = dqsurf(1:ngridmx,1:nqmx) + zdqssed(1:ngridmx,1:nqmx)
+           pdq(1:ngrid,1:nlayermx,1:nq) = pdq(1:ngrid,1:nlayermx,1:nq) + zdqsed(1:ngrid,1:nlayermx,1:nq)
+           dqsurf(1:ngrid,1:nq) = dqsurf(1:ngrid,1:nq) + zdqssed(1:ngrid,1:nq)
 
            !-------------------------
@@ -1205,13 +1242,13 @@
          if(mass_redistrib) then
 
-            zdmassmr(1:ngridmx,1:nlayermx) = mass(1:ngridmx,1:nlayermx) * &
-	       (   zdqevap(1:ngridmx,1:nlayermx)                          &
-	         + zdqrain(1:ngridmx,1:nlayermx,igcm_h2o_vap)             &
-		 + dqmoist(1:ngridmx,1:nlayermx,igcm_h2o_vap)             &
-		 + dqvaplscale(1:ngridmx,1:nlayermx) )
+            zdmassmr(1:ngrid,1:nlayermx) = mass(1:ngrid,1:nlayermx) * &
+	       (   zdqevap(1:ngrid,1:nlayermx)                          &
+	         + zdqrain(1:ngrid,1:nlayermx,igcm_h2o_vap)             &
+		 + dqmoist(1:ngrid,1:nlayermx,igcm_h2o_vap)             &
+		 + dqvaplscale(1:ngrid,1:nlayermx) )
 		 
             
-	    call writediagfi(ngridmx,"mass_evap","mass gain"," ",3,zdmassmr)
-	    call writediagfi(ngridmx,"mass","mass"," ",3,mass)
+	    call writediagfi(ngrid,"mass_evap","mass gain"," ",3,zdmassmr)
+	    call writediagfi(ngrid,"mass","mass"," ",3,mass)
 
 	    call mass_redistribution(ngrid,nlayer,nq,ptimestep,   &
@@ -1221,11 +1258,11 @@
 	 
 
-            pdq(1:ngridmx,1:nlayermx,1:nqmx) = pdq(1:ngridmx,1:nlayermx,1:nqmx) + zdqmr(1:ngridmx,1:nlayermx,1:nqmx)
-            dqsurf(1:ngridmx,1:nqmx)         = dqsurf(1:ngridmx,1:nqmx) + zdqsurfmr(1:ngridmx,1:nqmx)
-            pdt(1:ngridmx,1:nlayermx)        = pdt(1:ngridmx,1:nlayermx) + zdtmr(1:ngridmx,1:nlayermx)
-            pdu(1:ngridmx,1:nlayermx)        = pdu(1:ngridmx,1:nlayermx) + zdumr(1:ngridmx,1:nlayermx)
-            pdv(1:ngridmx,1:nlayermx)        = pdv(1:ngridmx,1:nlayermx) + zdvmr(1:ngridmx,1:nlayermx)
-	    pdpsrf(1:ngridmx)                = pdpsrf(1:ngridmx) + zdpsrfmr(1:ngridmx)
-            zdtsurf(1:ngridmx)               = zdtsurf(1:ngridmx) + zdtsurfmr(1:ngridmx)
+            pdq(1:ngrid,1:nlayermx,1:nq) = pdq(1:ngrid,1:nlayermx,1:nq) + zdqmr(1:ngrid,1:nlayermx,1:nq)
+            dqsurf(1:ngrid,1:nq)         = dqsurf(1:ngrid,1:nq) + zdqsurfmr(1:ngrid,1:nq)
+            pdt(1:ngrid,1:nlayermx)        = pdt(1:ngrid,1:nlayermx) + zdtmr(1:ngrid,1:nlayermx)
+            pdu(1:ngrid,1:nlayermx)        = pdu(1:ngrid,1:nlayermx) + zdumr(1:ngrid,1:nlayermx)
+            pdv(1:ngrid,1:nlayermx)        = pdv(1:ngrid,1:nlayermx) + zdvmr(1:ngrid,1:nlayermx)
+	    pdpsrf(1:ngrid)                = pdpsrf(1:ngrid) + zdpsrfmr(1:ngrid)
+            zdtsurf(1:ngrid)               = zdtsurf(1:ngrid) + zdtsurfmr(1:ngrid)
 	    
 !	    print*,'after mass redistrib, q=',pq(211,1:nlayermx,igcm_h2o_vap)+ptimestep*pdq(211,1:nlayermx,igcm_h2o_vap) 
@@ -1240,10 +1277,10 @@
          if(hydrology)then
 
-            call hydrol(ptimestep,rnat,tsurf,qsurf,dqsurf,dqs_hyd,    &
+            call hydrol(ngrid,nq,ptimestep,rnat,tsurf,qsurf,dqsurf,dqs_hyd,    &
                capcal,albedo0,albedo,mu0,zdtsurf,zdtsurf_hyd,hice)
             ! note: for now, also changes albedo in the subroutine
 
-            zdtsurf(1:ngridmx) = zdtsurf(1:ngridmx) + zdtsurf_hyd(1:ngridmx)
-            qsurf(1:ngridmx,1:nqmx) = qsurf(1:ngridmx,1:nqmx) + ptimestep*dqs_hyd(1:ngridmx,1:nqmx)
+            zdtsurf(1:ngrid) = zdtsurf(1:ngrid) + zdtsurf_hyd(1:ngrid)
+            qsurf(1:ngrid,1:nq) = qsurf(1:ngrid,1:nq) + ptimestep*dqs_hyd(1:ngrid,1:nq)
             ! when hydrology is used, other dqsurf tendencies are all added to dqs_hyd inside
 
@@ -1269,5 +1306,5 @@
          ELSE     ! of if (hydrology)
 
-            qsurf(1:ngridmx,1:nqmx)=qsurf(1:ngridmx,1:nqmx)+ptimestep*dqsurf(1:ngridmx,1:nqmx)
+            qsurf(1:ngrid,1:nq)=qsurf(1:ngrid,1:nq)+ptimestep*dqsurf(1:ngrid,1:nq)
 
          END IF   ! of if (hydrology)
@@ -1280,5 +1317,5 @@
 
          if(ice_update)then
-            ice_min(1:ngridmx)=min(ice_min(1:ngridmx),qsurf(1:ngridmx,igcm_h2o_ice))
+            ice_min(1:ngrid)=min(ice_min(1:ngrid),qsurf(1:ngrid,igcm_h2o_ice))
          endif
 
@@ -1291,9 +1328,9 @@
 
 !     Increment surface temperature
-      tsurf(1:ngridmx)=tsurf(1:ngridmx)+ptimestep*zdtsurf(1:ngridmx) 
+      tsurf(1:ngrid)=tsurf(1:ngrid)+ptimestep*zdtsurf(1:ngrid) 
 
 !     Compute soil temperatures and subsurface heat flux
       if (callsoil) then
-         call soil(ngrid,nsoilmx,.false.,inertiedat,        &
+         call soil(ngrid,nsoilmx,.false.,lastcall,inertiedat,   &
                 ptimestep,tsurf,tsoil,capcal,fluxgrd)
       endif
@@ -1317,14 +1354,14 @@
  
       ! temperature, zonal and meridional wind
-      zt(1:ngridmx,1:nlayermx) = pt(1:ngridmx,1:nlayermx) + pdt(1:ngridmx,1:nlayermx)*ptimestep
-      zu(1:ngridmx,1:nlayermx) = pu(1:ngridmx,1:nlayermx) + pdu(1:ngridmx,1:nlayermx)*ptimestep
-      zv(1:ngridmx,1:nlayermx) = pv(1:ngridmx,1:nlayermx) + pdv(1:ngridmx,1:nlayermx)*ptimestep
+      zt(1:ngrid,1:nlayermx) = pt(1:ngrid,1:nlayermx) + pdt(1:ngrid,1:nlayermx)*ptimestep
+      zu(1:ngrid,1:nlayermx) = pu(1:ngrid,1:nlayermx) + pdu(1:ngrid,1:nlayermx)*ptimestep
+      zv(1:ngrid,1:nlayermx) = pv(1:ngrid,1:nlayermx) + pdv(1:ngrid,1:nlayermx)*ptimestep
 
       ! diagnostic
-      zdtdyn(1:ngridmx,1:nlayermx)     = pt(1:ngridmx,1:nlayermx)-ztprevious(1:ngridmx,1:nlayermx)
-      ztprevious(1:ngridmx,1:nlayermx) = zt(1:ngridmx,1:nlayermx)
+      zdtdyn(1:ngrid,1:nlayermx)     = pt(1:ngrid,1:nlayermx)-ztprevious(1:ngrid,1:nlayermx)
+      ztprevious(1:ngrid,1:nlayermx) = zt(1:ngrid,1:nlayermx)
 
       if(firstcall)then
-         zdtdyn(1:ngridmx,1:nlayermx)=0.0
+         zdtdyn(1:ngrid,1:nlayermx)=0.0
       endif
 
@@ -1335,13 +1372,13 @@
 
       ! tracers
-      zq(1:ngridmx,1:nlayermx,1:nqmx) = pq(1:ngridmx,1:nlayermx,1:nqmx) + pdq(1:ngridmx,1:nlayermx,1:nqmx)*ptimestep
+      zq(1:ngrid,1:nlayermx,1:nq) = pq(1:ngrid,1:nlayermx,1:nq) + pdq(1:ngrid,1:nlayermx,1:nq)*ptimestep
 
       ! surface pressure
-      ps(1:ngridmx) = pplev(1:ngridmx,1) + pdpsrf(1:ngridmx)*ptimestep
+      ps(1:ngrid) = pplev(1:ngrid,1) + pdpsrf(1:ngrid)*ptimestep
 
       ! pressure
       do l=1,nlayer
-          zplev(1:ngridmx,l) = pplev(1:ngridmx,l)/pplev(1:ngridmx,1)*ps(:)
-          zplay(1:ngridmx,l) = pplay(1:ngridmx,l)/pplev(1:ngridmx,1)*ps(1:ngridmx)
+          zplev(1:ngrid,l) = pplev(1:ngrid,l)/pplev(1:ngrid,1)*ps(:)
+          zplay(1:ngrid,l) = pplay(1:ngrid,l)/pplev(1:ngrid,1)*ps(1:ngrid)
       enddo
 
@@ -1373,5 +1410,5 @@
          GND = SUM(area(:)*fluxgrd(:))/totarea
          DYN = SUM(area(:)*fluxdyn(:))/totarea
-         do ig=1,ngrid             
+         do ig=1,ngrid
             if(fluxtop_dn(ig).lt.0.0)then
                print*,'fluxtop_dn has gone crazy'
@@ -1385,5 +1422,5 @@
          end do
                      
-         if(ngridmx.eq.1)then
+         if(ngrid.eq.1)then
             DYN=0.0
          endif
@@ -1399,5 +1436,5 @@
 
          if(meanOLR)then
-            if((ngridmx.gt.1) .or. (mod(icount-1,nint(ecritphy)).eq.0))then
+            if((ngrid.gt.1) .or. (mod(icount-1,nint(ecritphy)).eq.0))then
                ! to record global radiative balance
                open(92,file="rad_bal.out",form='formatted',position='append')
@@ -1432,7 +1469,7 @@
 !     ---------------------------------------------------------
       if(tracer)then
-         qcol(1:ngridmx,1:nqmx)=0.0
+         qcol(1:ngrid,1:nq)=0.0
          do iq=1,nq
-           do ig=1,ngridmx
+           do ig=1,ngrid
               qcol(ig,iq) = SUM( zq(ig,1:nlayermx,iq) * mass(ig,1:nlayermx))
            enddo
@@ -1440,14 +1477,20 @@
 
          ! Generalised for arbitrary aerosols now. (LK)
-         reffcol(1:ngridmx,1:naerkind)=0.0
+         reffcol(1:ngrid,1:naerkind)=0.0
          if(co2cond.and.(iaero_co2.ne.0))then
-            call co2_reffrad(zq,reffrad)
-            do ig=1,ngridmx
+            call co2_reffrad(ngrid,nq,zq,reffrad)
+            do ig=1,ngrid
                reffcol(ig,iaero_co2) = SUM(zq(ig,1:nlayermx,igcm_co2_ice)*reffrad(ig,1:nlayermx,iaero_co2)*mass(ig,1:nlayermx))
             enddo
          endif
          if(water.and.(iaero_h2o.ne.0))then
-            call h2o_reffrad(zq,zt,reffrad,nueffrad)
-            do ig=1,ngridmx
+
+            !! AS: This modifies reffrad and nueffrad
+            !!     ... and those are saved in physiq
+            !!     To be conservative with previous versions,
+            !!     ... I put nueffrad_dummy so that nueffrad
+            !!     ... is not modified, but shouldn't it be modified actually?
+            call h2o_reffrad(ngrid,nq,zq,zt,reffrad,nueffrad_dummy)
+            do ig=1,ngrid
                reffcol(ig,iaero_h2o) = SUM(zq(ig,1:nlayermx,igcm_h2o_ice)*reffrad(ig,1:nlayermx,iaero_h2o)*mass(ig,1:nlayermx))
             enddo
@@ -1474,5 +1517,5 @@
 
          if(meanOLR)then
-            if((ngridmx.gt.1) .or. (mod(icount-1,nint(ecritphy)).eq.0))then
+            if((ngrid.gt.1) .or. (mod(icount-1,nint(ecritphy)).eq.0))then
                ! to record global water balance
                open(98,file="h2o_bal.out",form='formatted',position='append')
@@ -1490,5 +1533,5 @@
       if(water)then
          do l = 1, nlayer
-            do ig = 1, ngrid
+            do ig=1,ngrid
 !               call watersat(pt(ig,l),pplay(ig,l),qsat(ig,l))
                call Psat_water(zt(ig,l),pplay(ig,l),psat_tmp,qsat(ig,l))
@@ -1524,5 +1567,5 @@
             if(ice_update)then
 
-               do ig = 1, ngrid
+               do ig=1,ngrid
 
                   delta_ice = (qsurf(ig,igcm_h2o_ice)-ice_initial(ig))
@@ -1550,8 +1593,8 @@
 
             write(*,*)'PHYSIQ: for physdem ztime_fin =',ztime_fin
-            call physdem1("restartfi.nc",long,lati,nsoilmx,nq,            &
+            call physdem1(ngrid,"restartfi.nc",long,lati,nsoilmx,nq,            &
                     ptimestep,pday,ztime_fin,tsurf,tsoil,emis,q2,qsurf_hist, &
                     area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,      &
-                    cloudfrac,totcloudfrac,hice)
+                    cloudfrac,totcloudfrac,hice,noms)
          endif
 
@@ -1594,15 +1637,15 @@
              do iq=1,nq
                 call wstats(ngrid,noms(iq),noms(iq),'kg/kg',3,zq(1,1,iq))
-                call wstats(ngridmx,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
+                call wstats(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
                           'kg m^-2',2,qsurf(1,iq) )
 
-                call wstats(ngridmx,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
+                call wstats(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
                           'kg m^-2',2,qcol(1,iq) )
-!                call wstats(ngridmx,trim(noms(iq))//'_reff',                          & 
+!                call wstats(ngrid,trim(noms(iq))//'_reff',                          & 
 !                          trim(noms(iq))//'_reff',                                   & 
 !                          'm',3,reffrad(1,1,iq))
               end do
             if (water) then
-               vmr=zq(1:ngridmx,1:nlayermx,igcm_h2o_vap)*mugaz/mmol(igcm_h2o_vap)
+               vmr=zq(1:ngrid,1:nlayermx,igcm_h2o_vap)*mugaz/mmol(igcm_h2o_vap)
                call wstats(ngrid,"vmr_h2ovapor",                           &
                           "H2O vapour volume mixing ratio","mol/mol",       & 
@@ -1647,20 +1690,20 @@
 	if(enertest) then
 	  if (calldifv) then
-	     call writediagfi(ngridmx,"q2","turbulent kinetic energy","J.kg^-1",3,q2)
-!	     call writediagfi(ngridmx,"dEzdiff","turbulent diffusion heating (-sensible flux)","w.m^-2",3,dEzdiff)
-!	     call writediagfi(ngridmx,"dEdiff","integrated turbulent diffusion heating (-sensible flux)","w.m^-2",2,dEdiff)
-!	     call writediagfi(ngridmx,"dEdiffs","In TurbDiff (correc rad+latent heat) surf nrj change","w.m^-2",2,dEdiffs)
-	     call writediagfi(ngridmx,"sensibFlux","sensible heat flux","w.m^-2",2,sensibFlux)
+	     call writediagfi(ngrid,"q2","turbulent kinetic energy","J.kg^-1",3,q2)
+!	     call writediagfi(ngrid,"dEzdiff","turbulent diffusion heating (-sensible flux)","w.m^-2",3,dEzdiff)
+!	     call writediagfi(ngrid,"dEdiff","integrated turbulent diffusion heating (-sensible flux)","w.m^-2",2,dEdiff)
+!	     call writediagfi(ngrid,"dEdiffs","In TurbDiff (correc rad+latent heat) surf nrj change","w.m^-2",2,dEdiffs)
+	     call writediagfi(ngrid,"sensibFlux","sensible heat flux","w.m^-2",2,sensibFlux)
 	  endif
 	  if (corrk) then
-!	     call writediagfi(ngridmx,"dEzradsw","radiative heating","w.m^-2",3,dEzradsw)
-!	     call writediagfi(ngridmx,"dEzradlw","radiative heating","w.m^-2",3,dEzradlw)
+!	     call writediagfi(ngrid,"dEzradsw","radiative heating","w.m^-2",3,dEzradsw)
+!	     call writediagfi(ngrid,"dEzradlw","radiative heating","w.m^-2",3,dEzradlw)
 	  endif 
           if(watercond) then
 	     call writediagfi(ngrid,"lscaledE","heat from largescale","W m-2",2,lscaledE) 
 	     call writediagfi(ngrid,"madjdE","heat from moistadj","W m-2",2,madjdE)
-	     call writediagfi(ngridmx,"RH","relative humidity"," ",3,RH)
-!	     call writediagfi(ngridmx,"qsatatm","atm qsat"," ",3,qsat)
-!	     call writediagfi(ngridmx,"h2o_max_col","maximum H2O column amount","kg.m^-2",2,H2Omaxcol)
+	     call writediagfi(ngrid,"RH","relative humidity"," ",3,RH)
+!	     call writediagfi(ngrid,"qsatatm","atm qsat"," ",3,qsat)
+!	     call writediagfi(ngrid,"h2o_max_col","maximum H2O column amount","kg.m^-2",2,H2Omaxcol)
           endif 
         endif
@@ -1678,11 +1721,11 @@
 !     Output aerosols
         if (igcm_co2_ice.ne.0.and.iaero_co2.ne.0) &
-	  call writediagfi(ngridmx,'CO2ice_reff','CO2ice_reff','m',3,reffrad(1,1,iaero_co2))
+	  call writediagfi(ngrid,'CO2ice_reff','CO2ice_reff','m',3,reffrad(1,1,iaero_co2))
         if (igcm_h2o_ice.ne.0.and.iaero_h2o.ne.0) &
-	  call writediagfi(ngridmx,'H2Oice_reff','H2Oice_reff','m',3,reffrad(:,:,iaero_h2o))
+	  call writediagfi(ngrid,'H2Oice_reff','H2Oice_reff','m',3,reffrad(:,:,iaero_h2o))
         if (igcm_co2_ice.ne.0.and.iaero_co2.ne.0) &
-	  call writediagfi(ngridmx,'CO2ice_reffcol','CO2ice_reffcol','um kg m^-2',2,reffcol(1,iaero_co2))
+	  call writediagfi(ngrid,'CO2ice_reffcol','CO2ice_reffcol','um kg m^-2',2,reffcol(1,iaero_co2))
         if (igcm_h2o_ice.ne.0.and.iaero_h2o.ne.0) &
-	  call writediagfi(ngridmx,'H2Oice_reffcol','H2Oice_reffcol','um kg m^-2',2,reffcol(1,iaero_h2o))
+	  call writediagfi(ngrid,'H2Oice_reffcol','H2Oice_reffcol','um kg m^-2',2,reffcol(1,iaero_h2o))
 
 !     Output tracers
@@ -1690,9 +1733,9 @@
         do iq=1,nq
           call writediagfi(ngrid,noms(iq),noms(iq),'kg/kg',3,zq(1,1,iq))
-!          call writediagfi(ngridmx,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
+!          call writediagfi(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
 !                          'kg m^-2',2,qsurf(1,iq) )
-          call writediagfi(ngridmx,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
+          call writediagfi(ngrid,trim(noms(iq))//'_surf',trim(noms(iq))//'_surf',  & 
                           'kg m^-2',2,qsurf_hist(1,iq) )
-          call writediagfi(ngridmx,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
+          call writediagfi(ngrid,trim(noms(iq))//'_col',trim(noms(iq))//'_col',    & 
                           'kg m^-2',2,qcol(1,iq) )
 
@@ -1705,15 +1748,15 @@
 
           if(waterrain)then
-             call writediagfi(ngridmx,"rain","rainfall","kg m-2 s-1",2,zdqsrain)
-             call writediagfi(ngridmx,"snow","snowfall","kg m-2 s-1",2,zdqssnow)
+             call writediagfi(ngrid,"rain","rainfall","kg m-2 s-1",2,zdqsrain)
+             call writediagfi(ngrid,"snow","snowfall","kg m-2 s-1",2,zdqssnow)
           endif
 
           if(hydrology)then
-             call writediagfi(ngridmx,"hice","oceanic ice height","m",2,hice)
+             call writediagfi(ngrid,"hice","oceanic ice height","m",2,hice)
           endif
 
           if(ice_update)then
-             call writediagfi(ngridmx,"ice_min","min annual ice","m",2,ice_min)
-             call writediagfi(ngridmx,"ice_ini","initial annual ice","m",2,ice_initial)
+             call writediagfi(ngrid,"ice_min","min annual ice","m",2,ice_min)
+             call writediagfi(ngrid,"ice_ini","initial annual ice","m",2,ice_initial)
           endif
 
@@ -1725,5 +1768,5 @@
           end do
 
-          call writediagfi(ngridmx,"tau_col","Total aerosol optical depth","[]",2,tau_col)
+          call writediagfi(ngrid,"tau_col","Total aerosol optical depth","[]",2,tau_col)
 
         enddo
@@ -1739,10 +1782,89 @@
       icount=icount+1
 
-      ! deallocate gas variables
       if (lastcall) then
+
+        ! deallocate gas variables
         IF ( ALLOCATED( gnom ) ) DEALLOCATE( gnom )
         IF ( ALLOCATED( gfrac ) ) DEALLOCATE( gfrac )  ! both allocated in su_gases.F90
+
+        ! deallocate saved arrays
+        ! this is probably not that necessary
+        ! ... but probably a good idea to clean the place before we leave
+        IF ( ALLOCATED(tsurf)) DEALLOCATE(tsurf)
+        IF ( ALLOCATED(tsoil)) DEALLOCATE(tsoil)
+        IF ( ALLOCATED(albedo)) DEALLOCATE(albedo)
+        IF ( ALLOCATED(albedo0)) DEALLOCATE(albedo0)
+        IF ( ALLOCATED(rnat)) DEALLOCATE(rnat)
+        IF ( ALLOCATED(emis)) DEALLOCATE(emis)
+        IF ( ALLOCATED(dtrad)) DEALLOCATE(dtrad)
+        IF ( ALLOCATED(fluxrad_sky)) DEALLOCATE(fluxrad_sky)
+        IF ( ALLOCATED(fluxrad)) DEALLOCATE(fluxrad)
+        IF ( ALLOCATED(capcal)) DEALLOCATE(capcal)
+        IF ( ALLOCATED(fluxgrd)) DEALLOCATE(fluxgrd)
+        IF ( ALLOCATED(qsurf)) DEALLOCATE(qsurf)
+        IF ( ALLOCATED(q2)) DEALLOCATE(q2)
+        IF ( ALLOCATED(ztprevious)) DEALLOCATE(ztprevious)
+        IF ( ALLOCATED(cloudfrac)) DEALLOCATE(cloudfrac)
+        IF ( ALLOCATED(totcloudfrac)) DEALLOCATE(totcloudfrac)
+        IF ( ALLOCATED(qsurf_hist)) DEALLOCATE(qsurf_hist)
+        IF ( ALLOCATED(reffrad)) DEALLOCATE(reffrad)
+        IF ( ALLOCATED(nueffrad)) DEALLOCATE(nueffrad)
+        IF ( ALLOCATED(ice_initial)) DEALLOCATE(ice_initial)
+        IF ( ALLOCATED(ice_min)) DEALLOCATE(ice_min)
+
+        IF ( ALLOCATED(fluxsurf_lw)) DEALLOCATE(fluxsurf_lw)
+        IF ( ALLOCATED(fluxsurf_sw)) DEALLOCATE(fluxsurf_sw)
+        IF ( ALLOCATED(fluxtop_lw)) DEALLOCATE(fluxtop_lw)
+        IF ( ALLOCATED(fluxabs_sw)) DEALLOCATE(fluxabs_sw)
+        IF ( ALLOCATED(fluxtop_dn)) DEALLOCATE(fluxtop_dn)
+        IF ( ALLOCATED(fluxdyn)) DEALLOCATE(fluxdyn)
+        IF ( ALLOCATED(OLR_nu)) DEALLOCATE(OLR_nu)
+        IF ( ALLOCATED(OSR_nu)) DEALLOCATE(OSR_nu)
+        IF ( ALLOCATED(sensibFlux)) DEALLOCATE(sensibFlux)
+        IF ( ALLOCATED(zdtlw)) DEALLOCATE(zdtlw)
+        IF ( ALLOCATED(zdtsw)) DEALLOCATE(zdtsw)
+        IF ( ALLOCATED(tau_col)) DEALLOCATE(tau_col)
+
+        !! this is defined in comsaison_h
+        IF ( ALLOCATED(mu0)) DEALLOCATE(mu0)
+        IF ( ALLOCATED(fract)) DEALLOCATE(fract)
+
+        !! this is defined in comsoil_h
+        IF ( ALLOCATED(layer)) DEALLOCATE(layer)
+        IF ( ALLOCATED(mlayer)) DEALLOCATE(mlayer)
+        IF ( ALLOCATED(inertiedat)) DEALLOCATE(inertiedat)
+
+        !! this is defined in surfdat_h
+        IF ( ALLOCATED(albedodat)) DEALLOCATE(albedodat)
+        IF ( ALLOCATED(phisfi)) DEALLOCATE(phisfi)
+        IF ( ALLOCATED(zmea)) DEALLOCATE(zmea)
+        IF ( ALLOCATED(zstd)) DEALLOCATE(zstd)
+        IF ( ALLOCATED(zsig)) DEALLOCATE(zsig)
+        IF ( ALLOCATED(zgam)) DEALLOCATE(zgam)
+        IF ( ALLOCATED(zthe)) DEALLOCATE(zthe)
+        IF ( ALLOCATED(dryness)) DEALLOCATE(dryness)
+        IF ( ALLOCATED(watercaptag)) DEALLOCATE(watercaptag)
+ 
+        !! this is defined in tracer_h
+        IF ( ALLOCATED(noms)) DEALLOCATE(noms)
+        IF ( ALLOCATED(mmol)) DEALLOCATE(mmol)
+        IF ( ALLOCATED(radius)) DEALLOCATE(radius)
+        IF ( ALLOCATED(rho_q)) DEALLOCATE(rho_q)
+        IF ( ALLOCATED(qext)) DEALLOCATE(qext)
+        IF ( ALLOCATED(alpha_lift)) DEALLOCATE(alpha_lift)
+        IF ( ALLOCATED(alpha_devil)) DEALLOCATE(alpha_devil)
+        IF ( ALLOCATED(qextrhor)) DEALLOCATE(qextrhor)
+        IF ( ALLOCATED(igcm_dustbin)) DEALLOCATE(igcm_dustbin)
+
+        !! this is defined in comgeomfi_h
+        IF ( ALLOCATED(lati)) DEALLOCATE(lati)
+        IF ( ALLOCATED(long)) DEALLOCATE(long)
+        IF ( ALLOCATED(area)) DEALLOCATE(area)
+        IF ( ALLOCATED(sinlat)) DEALLOCATE(sinlat)
+        IF ( ALLOCATED(coslat)) DEALLOCATE(coslat)
+        IF ( ALLOCATED(sinlon)) DEALLOCATE(sinlon)
+        IF ( ALLOCATED(coslon)) DEALLOCATE(coslon)
+
       endif
-
 
       return
